"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require("babel-runtime/core-js/promise");

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _pg = require("pg");

var _pg2 = _interopRequireDefault(_pg);

var _debug = require("debug");

var _debug2 = _interopRequireDefault(_debug);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = (0, _debug2.default)("graphile-build-pg");

var withPgClient = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
    var pgConfig = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : process.env.DATABASE_URL;
    var fn = arguments[1];
    var releasePgClient, pgClient, result;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (fn) {
              _context.next = 2;
              break;
            }

            throw new Error("Nothing to do!");

          case 2:
            releasePgClient = function releasePgClient() {};

            pgClient = void 0;
            result = void 0;
            _context.prev = 5;

            if (!(pgConfig instanceof _pg2.default.Client)) {
              _context.next = 12;
              break;
            }

            pgClient = pgConfig;

            if (pgClient.release) {
              _context.next = 10;
              break;
            }

            throw new Error("We only support PG clients from a PG pool (because otherwise the `await` call can hang indefinitely if an error occurs and there's no error handler)");

          case 10:
            _context.next = 28;
            break;

          case 12:
            if (!(pgConfig instanceof _pg2.default.Pool)) {
              _context.next = 19;
              break;
            }

            _context.next = 15;
            return pgConfig.connect();

          case 15:
            pgClient = _context.sent;

            releasePgClient = function releasePgClient() {
              return pgClient.release();
            };
            _context.next = 28;
            break;

          case 19:
            if (!(pgConfig === undefined || typeof pgConfig === "string")) {
              _context.next = 27;
              break;
            }

            pgClient = new _pg2.default.Client(pgConfig);
            pgClient.on("error", function (e) {
              debug("pgClient error occurred: %s", e);
            });
            releasePgClient = function releasePgClient() {
              return new _promise2.default(function (resolve, reject) {
                return pgClient.end(function (err) {
                  return err ? reject(err) : resolve();
                });
              });
            };
            _context.next = 25;
            return new _promise2.default(function (resolve, reject) {
              return pgClient.connect(function (err) {
                return err ? reject(err) : resolve();
              });
            });

          case 25:
            _context.next = 28;
            break;

          case 27:
            throw new Error("You must provide a valid PG client configuration");

          case 28:
            _context.next = 30;
            return fn(pgClient);

          case 30:
            result = _context.sent;

          case 31:
            _context.prev = 31;
            _context.prev = 32;
            _context.next = 35;
            return releasePgClient();

          case 35:
            _context.next = 39;
            break;

          case 37:
            _context.prev = 37;
            _context.t0 = _context["catch"](32);

          case 39:
            return _context.finish(31);

          case 40:
            return _context.abrupt("return", result);

          case 41:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, undefined, [[5,, 31, 40], [32, 37]]);
  }));

  return function withPgClient() {
    return _ref.apply(this, arguments);
  };
}();

exports.default = withPgClient;
//# sourceMappingURL=withPgClient.js.map